var DiffType;
(function (DiffType) {
    DiffType["normal"] = "normal";
    DiffType["deleted"] = "deleted";
    DiffType["created"] = "created";
})(DiffType || (DiffType = {}));
// myers algorithm
function diffList(props) {
    var before = props.before, after = props.after, getId = props.getId;
    var n = before.length;
    var m = after.length;
    var max = n + m;
    var trace = [];
    var x;
    var y;
    loop: for (var d = 0; d <= max; d += 1) {
        var v = {};
        trace.push(v);
        if (d === 0) {
            var t = 0;
            while (t < before.length &&
                t < after.length &&
                getId(before[t]) === getId(after[t])) {
                t += 1;
            }
            v[0] = t;
            if (t === before.length && t === after.length) {
                break loop;
            }
            continue;
        }
        var lastV = trace[d - 1];
        for (var k_1 = -d; k_1 <= d; k_1 += 2) {
            if (k_1 === -d || (k_1 !== d && lastV[k_1 - 1] < lastV[k_1 + 1])) {
                // down
                x = lastV[k_1 + 1];
            }
            else {
                // right
                x = lastV[k_1 - 1] + 1;
            }
            y = x - k_1;
            while (x < n &&
                y < m &&
                getId(before[x]) === getId(after[y])) {
                x += 1;
                y += 1;
            }
            v[k_1] = x;
            if (x === n && y === m) {
                break loop;
            }
        }
    }
    var operations = [];
    x = n;
    y = m;
    var k;
    for (var d = trace.length - 1; d > 0; d -= 1) {
        k = x - y;
        var lastV = trace[d - 1];
        var prevK = void 0;
        if (k === -d || (k !== d && lastV[k - 1] < lastV[k + 1])) {
            prevK = k + 1;
        }
        else {
            prevK = k - 1;
        }
        var prevX = lastV[prevK];
        var prevY = prevX - prevK;
        while (x > prevX && y > prevY) {
            operations.push(DiffType.normal);
            x -= 1;
            y -= 1;
        }
        if (x === prevX) {
            operations.push(DiffType.created);
        }
        else {
            operations.push(DiffType.deleted);
        }
        x = prevX;
        y = prevY;
    }
    if (trace[0][0] !== 0) {
        for (var i = 0; i < trace[0][0]; i += 1) {
            operations.push(DiffType.normal);
        }
    }
    operations.reverse();
    var srcIdx = 0;
    var dstIdx = 0;
    var arr = [];
    operations.forEach(function (type) {
        switch (type) {
            case DiffType.created:
                arr.push({
                    id: getId(after[dstIdx]),
                    after: after[dstIdx],
                    type: type,
                });
                dstIdx += 1;
                break;
            case DiffType.normal:
                arr.push({
                    id: getId(after[dstIdx]),
                    before: before[srcIdx],
                    after: after[dstIdx],
                    type: type,
                });
                srcIdx += 1;
                dstIdx += 1;
                break;
            case DiffType.deleted:
                arr.push({
                    id: getId(before[srcIdx]),
                    before: before[srcIdx],
                    type: type,
                });
                srcIdx += 1;
                break;
        }
    });
    return arr;
}

export { DiffType, diffList };
//# sourceMappingURL=diff-list-myers.es5.js.map
