export declare enum DiffType {
    normal = "normal",
    deleted = "deleted",
    created = "created"
}
export declare type DiffValue<T> = ({
    id: string;
    before: T;
    type: DiffType.deleted;
}) | ({
    id: string;
    before: T;
    after: T;
    type: DiffType.normal;
}) | ({
    id: string;
    after: T;
    type: DiffType.created;
});
export declare function diffList<T>(props: {
    before: T[];
    after: T[];
    getId(v: T): string;
}): DiffValue<T>[];
